#!/bin/sh
# DHO800/DHO900 UNLOCK TOOLS Script for MacOS
# assumes go is on your PATH
# usage:
# with backup:
#   ./run_dho_tools.sh
# with no backup:
#   ./run_dho_tools.sh -n 

# Change these lines as necessary
export IpAddress=192.168.1.248
export ADB=/opt/platform-tools/adb
# export options="BODE BW15T25" # for 914S
export options="BW15T25" # for 914
export scopeID=DH09 # or DH08 for DHO814/DHO824

# These should not need changing:
export formatCmd=:SYSTem:OPTion:INSTall
export AdbPort=55555

adb_connect() {
    $ADB devices
    $ADB connect $IpAddress:$AdbPort
}

adb_pull_key() {
    $ADB pull /rigol/data/Key.data ./
}

adb_remove_ALL_options() {
    $ADB shell rm '/rigol/data/*.lic'
}

list_rigol_data_dir() {
    $ADB shell ls -l /rigol/data
}

make_backup_and_pull_it() {
    $ADB shell rm /rigol/DHO800_DHO900_Update.GEL
    $ADB shell cd /rigol\;sh build_gel.sh
    mkdir -p ./backup
    $ADB pull rigol/DHO800_DHO900_Update.GEL ./backup/
}

adb_connect

echo "Here you can find all *.lic files of options already installed:"
list_rigol_data_dir

if [ "$1" = "-n" ]; then
  echo "NOT making backup"
else
  echo "Making backup, see the \"backup\" folder (you can install it from a flash drive, as you do it with the official update)"
  make_backup_and_pull_it
fi

# Download your key for the rgtoolMod.go
adb_pull_key

echo "go run rgtoolMod.go"
go run "hdo-tools-master/rgtoolMod.go" Key.data $scopeID $formatCmd $options

echo "Please, send generated $formatCmd commands to the scope via the SCPI interface, and press any key to check for the new *.lic files."
echo "Options are installed without scope reboot."

open http://$IpAddress/scpi.html

read -p "Press any key to continue... " -n1 -s

echo "Here you can find all *.lic files of options already installed:"
list_rigol_data_dir

read -p "Press any key to continue... " -n1 -s

# All options listed in the firmware V1.01:

# OPT_AERO OPT_ARINC OPT_AUDIO OPT_AUTO OPT_BND 
# OPT_BODE OPT_BW10T20 OPT_BW15T25 OPT_BW2T4 OPT_BW2T8 OPT_BW4T8 OPT_BW7T10 OPT_BW7T15 OPT_BW7T20 
# OPT_CM_ENET OPT_CM_HDMI OPT_CM_MIPI OPT_CM_USB 
# OPT_COMP OPT_COUNT OPT_DG OPT_EMBD OPT_EYE OPT_FLEX OPT_JITTER OPT_MSO OPT_PWR OPT_RLU OPT_RTSA OPT_UNKNOWN OPT_UPA
